%MATLAB script for Example 3.2b on page 87 of conte/deboor
f1 = @(v) 50*1e-8*(exp(40*v)-1) + v - 20; f1p = @(v) 50*1e-8*40*exp(40*v)-1;
f2 = @(v) 50*1e-6*(exp(20*v)-1) + v - 20; f2p = @(v) 50*1e-6*20*exp(20*v)-1;

xtol = 1e-8; ftol = 1e-7;

    % try the first problem

disp('      I = 1e-8, q = 40 ')
disp('   XN            FXN ')
x = 0;  
while 1
   fx = f1(x); if abs(fx) <= ftol, break, end
   fprintf(' %15.7e   %15.7e \n',[x,fx])
   h = -f1(x)/f1p(x); x = x + h;
   if (abs(h) <= xtol, break, end
end
pause

disp('      I = 1e-6, q = 20 ')
disp('   XN            FXN ')
x = 0;  
while 1
   fx = f1(x); if abs(fx) <= ftol, break, end
   fprintf(' %15.7e   %15.7e \n',[x,fx])
   h = -f1(x)/f1p(x); x = x + h;
   if (abs(h) <= xtol, break, end
end

